/*
 * GetKeyboard.c
 *
 * Purpose:
 * --------
 * Gestion du terminal de sortie (Minitel, Modem)
 *
 * History:
 * --------
 * 1993: fplanque: Created
 */

 
 	#include "!OPTIONS.H"				/* Options de compilation */         
	#define	THIS_FILE	"GETKEYBD.C v2.97 - 04.95"
          

/*
 * System headers:
 */
	#include	<stdio.h>
	#include <string.h>
	#include	<tos.h>					/* Pour les appels au BIOS */
   

/*
 * Custom headers:
 */
	#include "SPEC_PU.H"
	#include "S_MALLOC.H"
	#include	"DEF_ARBO.H"	
	#include "SERV_PU.H"				/* Codes touches etc... */
	#include "IOFLD_PU.H"	
	#include	"DEBUG_PU.H"	
	#include	"TEXT_PU.H"	
	#include "TERM_PU.H"
	#include "ACCENTPU.H"
	#include "MINITEL.H"				/* Codes minitel */


/*
 * PRIVate INTernal prototypes:
 */
	static	void	get_keyboard_TypeCar( 
							int	device,
							int	keycode );
	static	void	getKeyb_SelectColor(
								int	n_color );			/* In: Couleur dsire */
	static	int	getKeyb_Annulation( void );	/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
	static	int	getKeyb_Correction( void );	/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
	static	int	getKeyb_Retour( void );			/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
	static	int	getKeyb_Suite( void );			/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
	static	void	getKeyb_InsLine( void );
	static	void	getKeyb_SupLine( void );
	static	int	getKeyb_InputFilter(			/* Out: Code filtr, NIL_1 si refus */
								int	n_KeyCode	);	/* In:  Code reu */
	static	void	getKeyb_WriteChar(
								int keycode );			/* In: caractre  crire dans le texte en cours d'dition */
	static	void	getKeyb_makeNextLine_current( void );
	static	void	getKeyb_EndLine( void );
	
	void	getKeyb_DebugDisplay( 
				TEXTINFO	*pTextInfo );

/*
 * Private variables: 
 */
	/* 
	 * Saisie clavier: 
	 */
	static	int			M_device;						/* No priphrique concern */
	static	EDIT_MODE	M_EditMode;						/* Mode d'dition en cours */
	static	IOFIELD	*	M_pInField;						/* Params champ courant */
	static	int			M_min_x, M_min_y;				/* Coord minimales que l'on peur atteindre pendant l'dition */
	static	int			M_max_x, M_max_y;				/* Coord maximales que l'on peut atteindre pendant l'dition */
	static	int			M_max_w;							/* Largeur maximale */
	static	long			M_l_CurrLine;					/* No de ligne courante */
	static	long			M_l_MaxNbLines;				/* Nbre de lignes maximum autoris */
	static	INFIELD_FLAGS	M_FieldFlags;					/* Flags qualifiant le champ */
	static	int			M_text_color, M_n_FillColor;	/* Couleurs utilises */
	static	int			M_asc_fill;						/* Support */
	static	int			M_asc_cach;						/* Cache */
	static	int			M_n_Filter;						/* Filtre de saisie */
	static	TEXTINFO	*	M_pTextInfo_currField;		/* Champ en cours d'dition */
	static	TEXTLINE	*	M_curr_textline;				/* Ligne courante */
	static	char		*	M_curr_text;					/* Ptr sur texte de la ligne courante */
	static	int			M_cur_x;							/* Position actuelle du curseur */
	static	int			M_cur_y;	
	static	int			M_rel_x;							/* Position X relative au dbut de la ligne [0...n-1] */
	static	int			M_curr_tcolor;					/* Couleur actuellement utilise */


/*
 * ----------------------- SAISIE AU CLAVIER ---------------------------
 */


/*
 * get_keyboard(-)
 *
 * Purpose:
 * --------
 * Saisie d'infos au clavier connect s'il y en a
 *
 * History:
 * --------
 *     1993: fplanque: Created
 * 10.05.94: fplanque: Sorti test mode dition
 * 24.05.94: fplanque: Sorti getKeyb_WriteChar()
 * 24.05.94: traitement des caractres spciaux SS2
 * 15.08.94: traitement touche ANNULATION
 * 06.01.94: utilisation d'un filtre d'entre
 * 12.07.95: Introduction de modes d'dition multiples
 * 08.10.95: gestion CR
 */
KEYCODE	get_keyboard( 				/* Out: Code touche spciale ayant t presse */
					VOIE * pVoie )		/* In:  Ptr sur voie courante */
{
	#define	WATCH_INPUT		NO0

	/*
	 * Variables: 
	 */
	int		device = pVoie -> device;				/* Numro de port srie */
	int		entete_seq = pVoie -> entete_seq;	/* En-tte d'une squence */
	int		pro_compte = pVoie -> pro_compte;	/* Nbre de codes qu'il reste  recevoir ds une squence PRO x */
	int		csi		  = pVoie -> csi;				/* Code squence CSI */
	int		compose	  = pVoie -> compose;		/* Code de composition de caractre */
	int		keycode;										/* Code touche en cours de traitement */
	KEYCODE	resultat = KEY_NONE;						/* Pour l'instant pas de touche spciale presse */

	/*
	 * Init des variables d'dition: 
	 */
	M_device	 = device; 
	M_EditMode = GetEditMode( pVoie );
	switch( M_EditMode )
	{
		case	BUFFERING:
			M_curr_textline = pVoie -> curr_textline;				/* Buffer de sauvegarde */
			break;
			
		case	FIELDEDIT:
		{	/* 
			 * Si on est sur un champ d'dition: 
			 */
			INPUT_FPAR		* pInputFPar;
	
			M_pInField = pVoie -> pIOField_CurrIn;					/* Params Champ d'dition courant */
			M_pTextInfo_currField = M_pInField -> pTextInfo;	/* Champ courant */
			M_curr_textline = pVoie -> curr_textline;				/* Ligne courante */
		 	pInputFPar	= M_pInField -> FPar.Input;
		 
			/*
			 * Coordonnes maximales que le curseur peut atteindre
			 * ds le champ d'dition courant: 
			 */
			M_min_x = pInputFPar -> x;
			M_min_y = pInputFPar -> y;
			M_max_w = pInputFPar -> w;
			M_max_x = M_min_x + M_max_w -1;
			M_max_y = M_min_y + pInputFPar -> h -1;
			/*
			 * Gestion du nbre de lignes maximal:
			 */
			M_l_CurrLine = pVoie -> l_CurrLine;	/* No de ligne courante */
			M_l_MaxNbLines = pInputFPar -> l_MaxNbLines;
			/*
			 * Divers:
			 */
			M_FieldFlags = pInputFPar -> InFieldFlags;
			/*
			 * Couleurs: 
			 */
			M_text_color = pInputFPar -> col_text;
			M_n_FillColor = pInputFPar -> col_fill;
			M_curr_tcolor = pVoie -> curr_tcolor;
			/*
			 * Caractres: 
			 */
			M_asc_fill = pInputFPar -> asc_fill;
			M_asc_cach = pInputFPar -> asc_cach;
			if ( M_asc_fill < ' ' && M_asc_cach != NIL )
			{	/*
				 * Si pas de filler alors que le texte, lui, sera visible 
				 */
				M_asc_fill = ' ';	/* On effacera avec des espaces */
			}
			if ( M_asc_cach == NIL )
			{	/*
			 	 * Si on veut un texte transparent: 
			 	 */
				M_asc_cach = TAB;	/* A l'affichage, on ne fera que sauter  la position suivante */
			}
			/*
			 * Filtre de saisie:
			 */
			M_n_Filter = pInputFPar -> n_Filter;
			
			/*
			 * Position actuelle du curseur: 
			 */
			M_cur_x	= pVoie -> csr_x;
			M_cur_y	= pVoie -> csr_y;
			/* 
			 * Position x relative: 
			 */
			M_rel_x = M_cur_x - M_min_x;			/* Offset X par rapport au dbut du champ */
			/*
			 * Texte de la ligne courante: 
			 */
			M_curr_text = M_curr_textline -> text;
		}
			break;
			
	}


	/*
	 * Tant qu'il y a un code en entre: 
	 */
	while (	Bconstat ( M_device )	/* Si code dispo sur nitel */ 
			&& resultat == KEY_NONE )	/* Et pas de touche significative presse */
	{
		keycode = (int) Bconin ( M_device ) ;	/* Lit 1 code/caractre */

		/* printf( "\nKeycode: %X", keycode ); */

		/*
		 * Traite le code/caractre:
		 */
		if( pro_compte > 0 )
		{	/*
			 * Si ce code entre en compte pour une squence PROtocole 
			 */
			pro_compte --;				/* 1 car de -  recevoir */
			/* Le code/Caractre a t trait */
		}
		else
		{	/*
			 * On est pas en squence PROtocole 
			 */
			switch ( keycode )			/* Selon le code caractre... */
			{
				case	SEP:						/* Si c'est un SEP */
					/* printf("SEP "); */
					entete_seq = SEP;				/* On entre en mode squence SEP */
					break;
				
				case	SS2: 						/* Si c'est un SS2: caractre spcial du jeu G2 */
					entete_seq = SS2;				/* On entre en mode squence SS2 */
					break;

				case	ESC:						/* Si c'est un ESC */
					entete_seq = ESC;				/* On entre en mode squence ESC */
					break;

				default:							/* Caractre Standard */
					/*
					 * Teste si le code est affichable <=> s'il porte de l'info 
					 */
					if( keycode>=' ' && keycode<='}' )
					{	/*
						 * Si code ASCII Standard 
						 */
						/* printf("(Seq=%d) ",entete_seq); */
						switch( entete_seq )		/* Si on en en plein milieu d'une squence Minitel... */
						{
							case SEP:				
								/*
								 * Si on est en mode SEP 
								 */
								switch ( keycode )			/* On va savoir pourquoi... */
								{
									case	ENVOI:				
										resultat = KEY_ENVOI;		/* Appui sur ENVOI */
										break;

									case	RETOUR:
										resultat = getKeyb_Retour();
										break;

									case	REPET:
										resultat = KEY_REPET;		/* Appui sur REPET */
										break;

									case	GUIDE:
										#if DEBUG_DISPLAY != FALSE0
											getKeyb_DebugDisplay( M_pTextInfo_currField );
										#else
											resultat = KEY_GUIDE;		/* Appui sur GUIDE */
										#endif
										break;

									case	ANNUL:
										resultat = getKeyb_Annulation();
										break;

									case	SOMM:
										resultat = KEY_SOMM;		/* Appui sur SOMM */
										break;

									case	CORREC:
										resultat = getKeyb_Correction();
										break;

									case	SUITE:
										resultat = getKeyb_Suite();
										break;

									case	CNX_FIN:
										resultat = KEY_FIN;			/* Appui sur CNX_FIN */
										break;

									case	ACQ_OPPO:					/* Minitel mis en opposition */
									#if WATCH_INPUT
										printf("\x1BY\x34\x20>Opposition ");
									#endif
										/*
										 * Teste s'il faut enregistrer la reception de cet acquitement: 
										 */
										if ( pVoie -> action_progress == APG_CNXSTART )
										{	/*
											 * Si on est en dbut de phase de connexion: 
											 */
											pVoie -> action_progress = APG_SPEED;		/* OK, la vitesse modem a t fixe */
										}
										break;
									
									case	ACQ_CNX:						/* Connexion ou dconnexion physique du modem */
									#if WATCH_INPUT
										printf("\x1BY\x34\x20>Cnx/Dco physique du Modem ");
									#endif
										/* 
										 * Teste s'il faut ragir  la reception de cet acquitement: 
										 */
										switch ( pVoie -> action_progress )
										{
											case	APG_PORTEUSE:
												/*
												 * Si on est en phase de connexion et qu'on a prcdement envoyla porteuse: 
												 */
												resultat = ACT_CONNECT;								/* Connexion vient d'tre tablie */
												pVoie -> action_progress = APG_NONE;		/* Fin de procdure de connexion */
												break;
												
											case	APG_PHASE_DECO:
												/*
												 * Si on est en phase de dconnexion: 
												 */
												resultat = ACT_DISCONNECT;							/* Connexion vient d'tre interrompue */
												pVoie -> action_progress = APG_NONE;		/* Fin de procdure de dconnexion */
												break;
										}
										break;
									
									case	PHASE_CNX:					/* Phase de connexion/Dconnexion */
									#if WATCH_INPUT
										printf("\x1BY\x34\x20>Phase de connexion/dconnexion ");
									#endif
										/* 
										 * Teste s'il faut enregistrer/traiter la reception de cet acquitement: 
										 */
										switch ( pVoie -> action_progress )
										{
											case APG_SPEED:
												/* 
												 * Si on est en phase de connexion
												 * et qu'on a prcdement rgl 
												 * la vitesse modem: 
												 */
												pVoie -> action_progress = APG_PORTEUSE;		/* OK, la porteuse est envoye */
												break;
												
											case APG_PORTEUSE:
												/*
												 * Si on est en phase de connexion 
												 * et qu'on a prcdement envoy 
												 * une porteuse: 
												 * Ceci symbolyse la fin d'mission porteuse 
												 * Connexion a chou 
												 */
												resultat = ECHEC_CONNECT;							/* Connexion a choue */
												pVoie -> action_progress = APG_NONE;		/* Fin de procdure de connexion */
												break;

											default:
												/*
												 * Si on est en mode normal: 
												 */
												if ( 	pVoie -> action_progress != APG_NONE )					
												{
													ping();
												#if WATCH_INPUT
													printf("WARNING Action courante interrompue ");
												#endif
												}
		
												/*
												 * On entre en phase de dconnexion: 
												 */
												pVoie -> action_progress = APG_PHASE_DECO;		/* Dbut phase de dconnexion */
										}
										break;

									case	ACQ_RESET:					/* Reset mode vidotex (comprend retour en mode vidotex depuis mode tlinformatique) */
									#if WATCH_INPUT
										printf("\x1BY\x35\x20>RESET Vidotex ");
									#endif
										break;

									case	APPEL:
										/*
										 * Dtection d'appel: 
										 */
										resultat = EVT_APPEL;	/* Signale cette dtetcion au serveur */
										break;

								#if WATCH_INPUT
									default:
										printf("\x1BY\x35\x20>Code SEP INCONNU!!!:0x%X ", keycode );
								#endif
								}
								break;


							case SS2:
							{	/*
								 * Si on est en mode SS2:
								 */
								switch( keycode )
								{
									case	GRAVE:
									case	AIGU:
									case	CIRC:
									case	TREMA:
									case	CEDILLE:
										/*
										 * Caractre compos:
										 */
										compose = keycode;	/* Sauve l'accent concern */
										break;									
								
									default:
									{	/*
										 * Convertit car minitel -> PC8
										 */
										int equiv = convert_G2toAsc( keycode );
									
										/* printf(" \n car special: %c \n", equiv ); */
	
										/*
										 * Ecrit car ds texte:
										 */
										getKeyb_WriteChar( equiv );
									}
								}
							}
								break;


							case ESC:
								/*
								 * Si on est en mode ESCAPE:
								 */
								switch ( keycode )	/* On va savoir pourquoi... */
								{
									case	PRO1:					/* C'est un Acq PRO 1 */
										pro_compte = 1;
										break;
									
									case	PRO2:					/* C'est un Acq PRO 2 */
										pro_compte = 2;
										break;
									
									case	PRO3:					/* C'est un Acq PRO 3 */
										pro_compte = 3;
										break;								

									case	CSI:
										csi = CSI;				/* On passe du mode squence ESC au mode squence CSI */
										break;
									
									#if WATCH_INPUT
									default:
										printf("\x1BY\x35\x20>Code ESC INCONNU!!! ");
									#endif
								}
								break;
							
							default:
								/*
								 * Si on est pas en squence Iaire:
								 * Teste sequence IIaire: 
								 */	
								switch( csi )
								{
									case	CSI:
										/*
										 * Si on est en squence CSI: 
										 */
										switch( keycode )
										{
											case	0x3F:		/* ? Mode */
												csi = 0x3F;
												break;

											case	CSI_INSLINE:
												getKeyb_InsLine();
												csi = NIL;	/* On est plus en squence CSI */
												break;

											case	CSI_SUPLINE:
												getKeyb_SupLine();
												csi = NIL;	/* On est plus en squence CSI */
												break;
													
											default:
												#if WATCH_INPUT
												printf("\x1BY\x35\x20>Code CSI INCONNU!!! ");
												#endif
												csi = NIL;	/* On est plus en squence CSI */
										}
										break;

									case	0x3F:
									/* Mode... */
									#if WATCH_INPUT
										printf("\x1BY\x35\x20>Mode TELEINFORMATIQUE... ");
									#endif
										
										csi = NIL;	/* On est plus en squence CSI */
										break;										
									
								
									default:
										/*
										 * Si on est pas en squence CSI: 
										 */
										csi = NIL;	/* SECURITE */
										switch ( compose )
										{
											case	GRAVE:
											case	AIGU:
											case	CIRC:
											case	TREMA:
											case	CEDILLE:
											{	/*
												 * Si on est en squence composition de caractre: 
												 * Convertit car minitel -> PC8
												 */
												int equiv = convert_Compose2Asc( compose, keycode );
											
												/* printf(" \n car special: %c \n", equiv ); */
			
												/*
												 * Ecrit car ds texte:
												 */
												getKeyb_WriteChar( equiv );

												compose = NIL;	/* On est plus en squence composition */
											}
												break;										
											
											default:
												/*
												 * Si on est pas en squence CSI: 
												 */
												compose = NIL;		/* SECURITE */

												/*
												 * ------------------------------------
												 * Ecrit CARACTERE STANDARD ds message: 
												 * ------------------------------------
												 */
												getKeyb_WriteChar( keycode );
										}													
								}
						}
					}
					else
					{	/*
						 * On n'a pas un caractre ASCII standard:
						 * On commence par annuler la squence courante:
						 */
						csi = NIL;		/* On est plus en squence CSI */
						compose = NIL;	/* On est plus en squence composition */
						 
						switch( keycode )
						{
							case	CR:
							/*
							 * Carriage Return:
							 */
							return	KEY_CR;
						}
					}
					entete_seq = NIL;		/* On est plus en dbut de squence */
			}
		}
		/* Le code/Caractre a t trait */

	}	/* Fin de la boucle; on sort ds qu'il n'y a plus rien  saisir */

	/*
	 * Fin de traitement: 
	 */
	if( M_EditMode == FIELDEDIT )
	{	/*
		 * Si on est en dition: 
		 * Sauve variables d'dition: 
		 */
		pVoie -> curr_textline	= M_curr_textline;	/* Ligne courante */
		pVoie -> csr_x 			= M_cur_x;				/* Sauve position courante du curseur */
		pVoie -> csr_y 			= M_cur_y;
		pVoie -> curr_tcolor		= M_curr_tcolor;		/* Mmorise couleur texte actuellement utilise */
		pVoie -> l_CurrLine 		= M_l_CurrLine;		/* No de ligne courante */
	}

	/*
	 * Sauve variables de saisie: 
	 */
	pVoie -> entete_seq = entete_seq;	/* Sauve le mode de squence en cours */
	pVoie -> pro_compte = pro_compte;	/* Sauve le nbre de codes restant  recevoir pour PRO x */
	pVoie -> csi			= csi;			/* Sauve le mode squence CSI */
	pVoie -> compose		= compose;		/* Sauve le mode squence composition */

	/*
	 * Retourne code touche spciale presse: 
	 */
	return	resultat;

	#undef	WATCH_INPUT

}


/*
 * getKeyb_DebugDisplay(-)
 *
 * Affiche le msg en cours d'dition sur l'cran ST pour debug
 *
 * Notes:
 * ------
 * Uniquement pour debugguer!
 *
 * 20.08.94: fplanque: Created
 */
#if DEBUG_DISPLAY == YES1
void	getKeyb_DebugDisplay( 
				TEXTINFO	*pTextInfo )
{
	TEXTLINE	* pTextLine = pTextInfo -> firstline -> next;
	char		* psz;
	int i;
	

	printf( "\x1BY  " );
		
	while( pTextLine != NULL )
	{
		if( (psz = pTextLine -> text) == NULL )
		{
			psz = "";
		}
		
		printf( "[" );
		for( i = 0; i < (pTextLine -> info1.bufsize); i++ )
		{
			printf( " " );
		}
		printf( "](%d/%d)\r[%s}\n", pTextLine -> length, pTextLine -> info1.bufsize, psz );
	
		pTextLine = pTextLine -> next;
	}

	printf( "--------------------------------------------" );
	
}
#endif


/*
 * getKeyb_Annulation(-)
 *
 * Purpose:
 * --------
 * Traite l'appui sur la touche annulation
 *
 * Notes:
 * ------
 *
 * History:
 * --------
 * 18.08.94: fplanque: extracted from get_keyboard
 * 24.09.94: pour l'instant ANNUL va renvoyer un code mme pdt l'dition
 */
int	getKeyb_Annulation( void )		/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
{				
	if( M_EditMode != FIELDEDIT )
	{	/*
		 * Si on est pas en dition: 
		 */
		return KEY_ANNUL;		/* Appui sur ANNUL */
	}
	else
	{	/*
		 * Si on est en dition: 
		 * Teste s'il y a qque chose  effacer: 
		 */
		if( M_cur_x > M_min_x )
		{	/*
			 * S'il y a qque chose  effacer:
			 */
			M_cur_x = M_min_x;				/* Csr en dbut Dbut de ligne */
			M_rel_x = 0;						/* Position relative */

			/*
			 * Effacement  l'cran: 
			 */
			if ( M_asc_fill >= ' ' )
			{	/*
				 * S'il faut effacer sur l'cran: 
				 */
				pos( M_device, M_cur_x, M_cur_y );	/* Positionne curseur  l'cran */
				M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */
				/* 
				 * On s'assure qu'on est en couleur SUPPORT: 
				 */
				getKeyb_SelectColor( M_n_FillColor );
				/*
				 * Raffiche une ligne vierge
				 */
				mconout( M_device, M_asc_fill, M_max_w );
			}											

			/*
			 * Positionne curseur pour prochaine saisie:
			 */
			pos( M_device, M_cur_x, M_cur_y );	/* Positionne curseur  l'cran */
			M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */

			/*
			 * Effacement ligne ds buffer d'dition:
			 */
			M_curr_textline -> length = 0;		/* Fixe longueur de la ligne */
			M_curr_text[ M_rel_x ] = '\0';		/* Fin de la ligne! */

		}
	}


	return KEY_ANNUL;		/* Appui sur ANNUL */

	/*
	 * Pas de touche significative presse:
	 */
	/* return	KEY_NONE; */
}




/*
 * getKeyb_Correction(-)
 *
 * Purpose:
 * --------
 * Traite l'appui sur la touche correction
 *
 * History:
 * --------
 * 18.08.94: fplanque: extracted from get_keyboard
 */
int	getKeyb_Correction( void )		/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
{				
	if( M_EditMode != FIELDEDIT 
		|| ( M_cur_x <= M_min_x && M_l_CurrLine <= 1 ) )
	{	/*
		 * Si on est pas en dition: 
		 * On s'il n'y a plus rien a effacer:
		 */
		return	KEY_CORREC;		/* Appui sur CORR */
	}

	/*
	 * S'il y a qque chose  effacer: 
	 */
	if ( M_cur_x == M_min_x )
	{	/*
		 * Si on est en dbut de ligne: 
		 * On remonte en fin de ligne prcdente
       * On y effacera 'l'espace' final...
		 */
		M_curr_textline	= M_curr_textline -> prev;		/* Ligne prcdente */												
		M_curr_text			= M_curr_textline -> text;		/* Texte ditable */	
		M_rel_x 				= M_curr_textline -> length;	/* Position relative */
		M_cur_x = M_min_x + M_rel_x;							/* Position  l'cran */
		M_l_CurrLine--;
		
		if( M_cur_x > M_max_x )
		{	/*
			 * Si pas d'espace final:
			 * On efface le dernier char
			 */
			M_rel_x --;
			M_cur_x --;
		}

		/*
		 * teste s'il faut scroller:
		 */
		if( M_cur_y <= M_min_y )
		{	/*
			 * Il faut scroller le champ de saisie:
			 */
			IOField_MoveTopLine( M_pInField, M_min_y - M_max_y -1 );
	
			/*
			 * Raffiche le champ  l'cran minitel:
			 */
			display_field( M_device, M_pInField, M_min_y, M_max_y );
	
			M_cur_y = M_max_y;	
		}
		else
		{	/*
			 * Pas besoin de scroller:
			 * Ligne prcdente:
			 */
			M_cur_y --;													/* ligne prcdente */
		}

		/*
		 * Mouvement csr  l'cran: 
		 */
		pos( M_device, M_cur_x, M_cur_y );	/* Positionne curseur  l'cran */
		M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */

	}
	else
	{	/*
		 * Si on est dans une ligne: 
		 */
		Bconout( M_device, BS );	/* Retour arrire */
		M_cur_x --;				/* On a dplac le curseur */
		M_rel_x --;				/* Position relative */
	}
													
	/*
	 * Effacement du car ds buffer d'dition:
	 */
	textEdit_delChar( M_curr_textline, M_rel_x );

	/*
	 * Effacement  l'cran: 
	 */
	if ( M_asc_fill >= ' ' )
	{	/*
		 * S'il faut effacer sur l'cran: 
		 * On s'Assure qu'on est en couleur SUPPORT: 
		 */
		getKeyb_SelectColor( M_n_FillColor );

		/* 
		 * Efface car ss curseur: 
		 */
		Bconout( M_device, M_asc_fill );	/* Fill */
		Bconout( M_device, BS );		/* Retour arrire */
	}											

	/*
	 * Pas de touche significative presse:
	 */
	return	KEY_NONE;
}



/*
 * getKeyb_Suite(-)
 *
 * Purpose:
 * --------
 * Traite l'appui sur la touche suite
 *
 * History:
 * --------
 * 18.08.94: fplanque: created
 * 22.08.94: caractre de continuit
 * 09.12.94: gestion monoparagarphe
 * 17.12.94: gestion des champs scrollants
 */
int	getKeyb_Suite( void )		/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
{				
	if( M_EditMode != FIELDEDIT  
		|| M_l_CurrLine >= M_l_MaxNbLines )
	{	/*
		 * Si on est pas en dition
		 * ou si on est sur la dernire ligne autorise:
		 */
		return KEY_SUITE;		/* Appui sur Suite */
	}

	/*
	 * Gestion monoparagraphe!
	 */	
	if( M_FieldFlags.b_MultiParagraph == FALSE0
		&&	M_curr_textline -> next == NULL )
	{	/*
		 * Si on est sur la dernire ligne tape et qu'on a pas droit  plusieurs paragraphes:
		 */
		return	KEY_SUITE;		/* Appui sur Suite */
	}

	/*
	 * Fin ligne actuelle:
	 */
	getKeyb_EndLine();

	/*
	 * Nouvelle ligne courante 
	 */
	getKeyb_makeNextLine_current();	
	M_l_CurrLine++;

	/*
	 * teste s'il faut scroller:
	 */
	if( M_cur_y >= M_max_y )
	{	/*
		 * Il faut scroller le champ de saisie!
		 */
		M_pInField -> pTextLine_Top	= M_curr_textline;
		M_pInField -> l_TopLine 		= M_l_CurrLine;
		 
		/*
		 * Raffiche le champ  l'cran minitel:
		 */
		display_field( M_device, M_pInField, M_min_y, M_max_y );

		M_cur_y = M_min_y;	
	}
	else
	{	/*
		 * Pas besoin de scroller, 
		 * on se contente de descendre sur la ligne suivante:
		 */
		M_cur_y ++;													/* ligne suivante */
	}

	/*
	 * rePositionne curseur  l'cran:
	 */
	pos( M_device, M_cur_x, M_cur_y );	
	M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */

	/*
	 * Pas de touche significative presse:
	 */
	return	KEY_NONE;
}


/*
 * getKeyb_Retour(-)
 *
 * Purpose:
 * --------
 * Traite l'appui sur la touche Retour
 *
 * SUGGEST:
 * ------
 * on peut groupper du code avec handleCorrection
 *
 * History:
 * --------
 * 20.08.94: fplanque: created based on getKeyb_Suite()
 * 18.12.94: gestion des champs scrollants
 */
int	getKeyb_Retour( void )		/* Out: rsultat  renvoyer vers l'appellant de get_keyboard() */
{				
	if( M_EditMode != FIELDEDIT 
		|| M_l_CurrLine <= 1 )
	{	/*
		 * Si on est pas en dition
		 * ou si on est sur la 1ere ligne
		 */
		return KEY_RETOUR;		/* Appui sur Retour */
	}

	/*
	 * S'il faut monter sur la ligne prcdente:
	 * Fin ligne actuelle:
	 */
	getKeyb_EndLine();

	/*
	 * Ligne prcdente:
	 */
	M_curr_textline	= M_curr_textline -> prev;		/* Ligne prcdente */												
	M_curr_text			= M_curr_textline -> text;		/* Texte ditable */	
	M_rel_x 				= M_curr_textline -> length;	/* Position relative */
	M_cur_x 				= M_min_x + M_rel_x;				/* Position  l'cran */
	M_l_CurrLine--;

	/*
	 * teste s'il faut scroller:
	 */
	if( M_cur_y <= M_min_y )
	{	/*
		 * Il faut scroller le champ de saisie:
		 */
		IOField_MoveTopLine( M_pInField, M_min_y - M_max_y -1 );

		/*
		 * Raffiche le champ  l'cran minitel:
		 */
		display_field( M_device, M_pInField, M_min_y, M_max_y );

		M_cur_y = M_max_y;	
	}
	else
	{	/*
		 * Pas besoin de scroller:
		 * Ligne prcdente:
		 */
		M_cur_y --;													/* ligne prcdente */
	}

	/*
	 * Positionne curseur  l'cran:
	 */
	pos( M_device, M_cur_x, M_cur_y );
	M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */

	/*
	 * Pas de touche significative presse:
	 */
	return	KEY_NONE;
}



/*
 * getKeyb_InsLine(-)
 *
 * Purpose:
 * --------
 * Traite l'appui sur la touche Ins.L
 *
 * History:
 * --------
 * 20.08.94: fplanque: created
 * 21.08.94: Raffichage sur l'cran
 */
void	getKeyb_InsLine( void )	
{				
	if( M_EditMode != FIELDEDIT )
	{	/*
		 * Si on est pas en dition: 
		 */
		return;
	}
	
	/*
	 * Insre une ligne vide:
	 */
	M_curr_textline = insert_line( M_curr_textline -> prev , NULL, NIL_1, M_pTextInfo_currField );

	/*
	 * Raffiche le champ  l'cran minitel:
	 */
	display_field( M_device, M_pInField, M_cur_y, M_max_y );

	/*
	 * Dtermine nouvelle position curseur:
	 */
	M_curr_text			= M_curr_textline -> text;		/* Texte ditable */	
	M_rel_x 				= M_curr_textline -> length;	/* Position relative */
	M_cur_x = M_min_x + M_rel_x;							/* Position  l'cran */

	/*
	 * Mouvement csr  l'cran: 
	 */
	pos( M_device, M_cur_x, M_cur_y );	/* Positionne curseur  l'cran */
	M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */
	
}



/*
 * getKeyb_SupLine(-)
 *
 * Purpose:
 * --------
 * Traite l'appui sur la touche Sup.L
 *
 * History:
 * --------
 * 21.08.94: fplanque: created
 */
void	getKeyb_SupLine( void )	
{				
	if( M_EditMode != FIELDEDIT  )
	{	
		return;
	}
	
	/*
	 * Si on est en dition: 
	 *
	 * Nouvelle ligne portant le curseur:
	 * Ligne suivant actuellement celle qu'on va effacer
	 */		
	getKeyb_makeNextLine_current();
	
	/* 
	 * Supprime la ligne qu'on vient de quitter:
	 */
	delete_line( M_curr_textline -> prev, M_pTextInfo_currField );

	/*
	 * Raffiche le champ  l'cran minitel:
	 */
	display_field( M_device, M_pInField, M_cur_y, M_max_y );

	/*
	 * Mouvement csr  l'cran: 
	 */
	pos( M_device, M_cur_x, M_cur_y );	/* Positionne curseur  l'cran */
	M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */
}


/*
 * getKeyb_InputFilter(-)
 *
 * Purpose:
 * --------
 * Filtre un caractre entr dans le champ courant
 *
 * History:
 * --------
 * 06.01.94: fplanque: Created
 */
int	getKeyb_InputFilter(		/* Out: Code filtr, NIL_1 si refus */
			int	n_KeyCode	)	/* In:  Code reu */
{
	switch( M_n_Filter )
	{
		case	FILTER_NONE:
			/*
			 * Accpte: tout code (>=32):
			 */
			return	n_KeyCode;
	
		case	FILTER_NUMERIC:
			/*
			 * Accpte: Chiffres 0-9
			 */
			if( n_KeyCode >= '0' && n_KeyCode <= '9' )
			{
				return	n_KeyCode;
			}
			return	NIL_1;

		case	FILTER_NAME_NOSPC:
			/*
			 * Accpte: Comme le suivant, sauf pas les espaces
			 */
			if( n_KeyCode == ' ' )
			{
				return	NIL_1;
			}
			/* ... */

		case	FILTER_NAME_SPACE:
			/*
			 * Accpte: Maj/Min - espace '
			 */
			if(   (n_KeyCode >= 'A' && n_KeyCode <= 'Z' )
				|| (n_KeyCode >= 'a' && n_KeyCode <= 'z' )
				||	 n_KeyCode == '-'
				||	 n_KeyCode == ' '
				||	 n_KeyCode == '\''	)
			{
				return	n_KeyCode;
			}
			return	NIL_1;


		case	FILTER_USERNAME:
			/*
			 * Accpte: Minuscules Chiffres _ - . 
			 * Conversion: Majuscules -> Minuscules
			 */
			if(   (n_KeyCode >= 'a' && n_KeyCode <= 'z' )
				|| (n_KeyCode >= '0' && n_KeyCode <= '9' )
				||	 n_KeyCode == '-'
				||	 n_KeyCode == '.'
				||	 n_KeyCode == '_'	)
			{
				return	n_KeyCode;
			}
			
			if( n_KeyCode >= 'A' && n_KeyCode <= 'Z' )
			{
				return	(n_KeyCode | 0x20 );
			}
			return	NIL_1;


		case	FILTER_PASSWORD:
			/*
			 * Accpte: Ascii de 33  123 sauf 94 et 96
			 */
			if(   n_KeyCode >= '!' && n_KeyCode <= 'z' 
				&&	n_KeyCode != '^'
				&& n_KeyCode != '`' )
			{
				return	n_KeyCode;
			}
			return	NIL_1;


		case	FILTER_ADDRESS:
			/*
			 * Accpte: Min/Maj Chiffres _ - . @
			 */
			if(   (n_KeyCode >= '@' && n_KeyCode <= 'Z' )
				|| (n_KeyCode >= 'a' && n_KeyCode <= 'z' )
				|| (n_KeyCode >= '0' && n_KeyCode <= '9' )
				||	 n_KeyCode == '-'
				||	 n_KeyCode == '.'
				||	 n_KeyCode == '_' )
			{
				return	n_KeyCode;
			}
			return	NIL_1;
	
		case	FILTER_PHONE:
			/*
			 * Accpte: Chiffres + , - . ( )
			 */
			if(   (n_KeyCode >= '0' && n_KeyCode <= '9' )
				|| (n_KeyCode >= '+' && n_KeyCode <= '.' )
				||	 n_KeyCode == '('
				||	 n_KeyCode == ')' )
			{
				return	n_KeyCode;
			}
			return	NIL_1;
	}

	signale( "Filtre d'entre inconnu/dtruit" );			
	return	n_KeyCode;
}


/*
 * getKeyb_WriteChar(-)
 *
 * Purpose:
 * --------
 * Ecriture d'un caractre 
 * ds texte en cours d'dition par getkeyboard()
 *
 * Suggest:
 * --------
 * Quand on passe  la ligne suivante et qu'il y a dj du texte:
 * traitement spcifique
 *
 * History:
 * --------
 * 24.05.94: fplanque: Created
 * 15.08.94: fplanque: enlev paramtre device, utilise maintenant M_device
 * 21.08.94: insre une ligne  chaque fois qu'on dborde la long max
 * 28.08.94: Csure automatique
 * 18.12.94: gestion des champs scrollables
 * 06.01.94: utilisation d'un filtre d'entre
 * 08.10.95: Gestion mode buffering
 */
void	getKeyb_WriteChar(
				int keycode )		/* In: caractre  crire dans le texte en cours d'dition */
{				
	switch( M_EditMode )
	{
		case	BUFFERING:
		{	/*
			 * On bufferise (pour DOWNLOAD par exemple):
			 */
			textEdit_addChar( M_curr_textline, M_curr_textline -> length, keycode, M_curr_textline -> info1.bufsize );
			/* printf( "\rBUFFER: [%s]  ", M_curr_textline -> text ); */
			break;
		}
		
		case	FIELDEDIT:
		{	/*
			 * Edition d'un champ:
			 */
			char *	pisz_LastSpace;
			char *	psz_NewLine = NULL;
			 
			/*
			 * Teste si on est en dition et si le champ n'est pas complet: 
			 */
			if( M_l_CurrLine >= M_l_MaxNbLines && M_cur_x > M_max_x  )
			{	/*
				 * S'il ne reste plus de place pour crire:
				 */
				return;
			}
		
			/*
			 * Il reste de la place pour crire:
			 * Vrifie que le caractre passe le filtre de saisie:
			 */
			keycode = getKeyb_InputFilter( keycode );
			if( keycode <= 0 )
			{
				return;
			}
		
			/*
			 * On s'assure qu'on est en couleur texte: 
			 */
			getKeyb_SelectColor( M_text_color );
		
			/*
			 * Affiche caractre: 
			 */
			if ( M_asc_cach == NUL )
			{	/*
			 	 * Si pas de cache: 
			 	 */
				cconout( M_device, keycode );		/* Affiche le code  l'cran */
			}
			else
			{	/*
				 * Si cache: 
				 */
				cconout( M_device, M_asc_cach);	/* Affiche du car cache  l'cran */
			}
		
			/*
			 * Mmorise le caractre: 
			 */
			textEdit_addChar( M_curr_textline, M_rel_x, keycode, M_max_w );
		
			/*
			 * Teste s'il faut passer  la ligne: 
			 */
			if( M_cur_x < M_max_x 
				|| M_l_CurrLine >= M_l_MaxNbLines )
			{	/*
				 * Il ne faut pas passer  la ligne: 
				 */
				M_cur_x ++;		/* Le curseur s'est dplac */
				M_rel_x ++;		/* Position relative */
			
				return;
			}
				
			/*
			 * S'il faut passer  la ligne: 
			 * Le paragraphe de la ligne courante continue sur la ligne suivante:
			 */
			M_curr_textline -> info1.continued = TRUE_1;		
		
			/*
			 * Recherche le dernier espace tap sur la ligne courante:
			 */
			if( (pisz_LastSpace = strBchr( M_curr_text, ' ' )) != NULL )
			{	/*
				 * Si on a trouv un espace,
				 * On va pouvoir couper la ligne  cet endroit:
				 */
				pisz_LastSpace[0] = '\0';	/* Fin de ligne */
				M_curr_textline -> length = (int)(pisz_LastSpace - M_curr_text);
				
				/*
				 * Rcupre la fin de ligne pour la ligne suivante:
				 */			
				psz_NewLine = STRDUP( &(pisz_LastSpace[1]) ); 
				
				/*
				 * Affiche finde ligne  l'cran
				 * et efface ce qui est report sur la suivante:
				 */
				pos( M_device, M_min_x + M_curr_textline -> length, M_cur_y );
				getKeyb_EndLine();
				mconout( M_device, M_asc_fill, M_max_w - M_curr_textline -> length -1 );
			}
		
			/*
			 * On se place sur la ligne suivante:
			 */
			getKeyb_makeNextLine_current();		/* Nouvelle ligne courante */
		
			/*
			 * Actuellement: (mode overwrite n'existe pas)
			 * On ne doit pas craser le texte de la ligne suivante
			 * donc on insre une ligne contenant ce qu'on a report depuis la ligne prcdente:
			 */
			M_curr_textline = insert_line( M_curr_textline -> prev , psz_NewLine, NIL_1, M_pTextInfo_currField );
		
			/*
			 * Dtermine nouvelle position curseur:
			 */
			M_curr_text			= M_curr_textline -> text;		/* Texte ditable */	
			M_rel_x 				= M_curr_textline -> length;	/* Position relative */
			M_cur_x = M_min_x + M_rel_x;							/* Position  l'cran */
		
			/*
			 * teste s'il faut scroller:
			 */
			if( M_cur_y >= M_max_y )
			{	/*
				 * Il faut scroller le champ de saisie!
				 */
				M_pInField -> pTextLine_Top	= M_curr_textline;
				M_pInField -> l_TopLine 		= M_l_CurrLine;
				 
				/*
				 * Raffiche le champ  l'cran minitel:
				 */
				display_field( M_device, M_pInField, M_min_y, M_max_y );
		
				M_cur_y = M_min_y;	
			}
			else
			{	/*
				 * Pas besoin de scroller, 
				 * on se contente de descendre sur la ligne suivante:
				 */
		
				/*
				 * Raffiche le champ  l'cran minitel:
				 */
				display_field( M_device, M_pInField, M_cur_y, M_max_y );
		
				M_cur_y ++;													/* ligne suivante */
			}
		
			/*
			 * Mouvement csr  l'cran: 
			 */
			pos( M_device, M_cur_x, M_cur_y );	/* Positionne curseur  l'cran */
			M_curr_tcolor = MBLANC;			/* Mmorise couleur actuellement utilise */

			break;
		}

		default:
			/*
			 * On est pas en dition:
			 * On ne fait rien
			 */
			break;
			
	}	/* Fin switch mode */
	
	return;
			
}



/*
 * getKeyb_makeNextLine_current(-)
 *
 * Purpose:
 * --------
 * Fait de la prochaine ligne du champ de saisie courant
 * la ligne courante!
 *
 * Notes:
 * ------
 * Pas d'oprations d'affichage
 *
 * History:
 * --------
 * 21.08.94: fplanque: Created
 */
void	getKeyb_makeNextLine_current( void )
{
	if( M_curr_textline -> next != NULL )
	{	/*
		 * On va simplement sur la ligne suivante:
		 */
		M_curr_textline = M_curr_textline -> next;		/* Ligne suivante */												
	}
	else
	{	/*
		 * Il n'y a pas de ligne suivante:
		 * On en cre une:
		 */
		M_curr_textline = insert_line( M_curr_textline, NULL, NIL_1, M_pTextInfo_currField );
	}



	M_curr_text			= M_curr_textline -> text;		/* Texte ditable */	
	M_rel_x 				= M_curr_textline -> length;	/* Position relative */
	M_cur_x = M_min_x + M_rel_x;							/* Position  l'cran */
}


/*
 * getKeyb_EndLine(-)
 *
 * Purpose:
 * --------
 * Affiche un caractre  l'cran traduisant si la ligne courante
 * est un fin de paragrphe ou non.
 *
 * Algorythm:
 * ----------  
 *
 * Notes:
 * ------
 *
 * History:
 * --------
 * 24.08.94: fplanque: Created
 */
void getKeyb_EndLine( void )
{

	/*
	 * On s'Assure qu'on est en couleur SUPPORT: 
	 */
	getKeyb_SelectColor( M_n_FillColor );

	if( M_curr_textline -> info1.continued )
	{	/*
		 * Le paragraphe continue sur la ligne suivante:
		 */
		cconout( M_device, PARAGRAPH_CONT );	
	}
	else
	{	/*
		 * Cette ligne marque la fin d'un paragraphe:
		 */
		cconout( M_device, PARAGRAPH_STOP );	
	}
}



/*
 * getKeyb_SelectColor(-)
 *
 * Purpose:
 * --------
 * Slection intelligente de la couleur d'criture 
 * ds texte en cours d'dition par getkeyboard()
 *
 * History:
 * --------
 * 15.08.94: fplanque: Created
 * 15.08.94: fplanque: enlev paramtre device, utilise maintenant M_device
 */
void	getKeyb_SelectColor(
					int	n_color )		/* In: Couleur dsire */
{
	/* 
	 * Vrifie si on est pas dj dans la couleur dsire: 
	 */
	if ( M_curr_tcolor != n_color )
	{	/*
		 * S'il faut fixer la couleur: 
		 */
		set_tcolor( M_device, n_color );	/* Couleur texte */
		M_curr_tcolor = n_color;			/* Mmorise couleur actuellement utilise */
	}
}

